#  Copyright (c) 2024 Feng Yang
#
#  I am making my contributions/submissions to this project solely in my
#  personal capacity and am not conveying any rights to any intellectual
#  property of any third parties.

from typing import override

from PySide6 import QtWidgets, QtGui, QtCore

from SpatialNode.basic_graphics_scene import BasicGraphicsScene

class ScaleRange:
    minimum: float = 0
    maximum: float = 0

class GraphicsView(QtWidgets.QGraphicsView):
    """
    A central view able to render objects from `BasicGraphicsScene`.
    """

    def __init__(self, scene: BasicGraphicsScene, parent=None):
        self._clearSelectionAction: QtGui.QAction | None = None
        self._deleteSelectionAction: QtGui.QAction | None = None
        self._duplicateSelectionAction: QtGui.QAction | None = None
        self._copySelectionAction: QtGui.QAction | None = None
        self._pasteAction: QtGui.QAction | None = None
        self._clickPos: QtCore.QPointF = None
        self._scaleRange: ScaleRange = None

    def clearSelectionAction(self) -> QtGui.QAction: ...
    def deleteSelectionAction(self) -> QtGui.QAction: ...
    @override
    def setScene(self, scene: BasicGraphicsScene): ...
    def centerScene(self) -> None: ...
    def setScaleRange(self, minimum: float = 0, maximum: float = 0) -> None: ...
    def getScale(self) -> float: ...

    scaleChanged: QtCore.Signal(float) = None

    def scaleUp(self) -> None: ...
    def scaleDown(self) -> None: ...
    def setupScale(self, scale: float) -> None: ...
    def onDeleteSelectedObjects(self) -> None: ...
    def onDuplicateSelectedObjects(self) -> None: ...
    def onCopySelectedObjects(self) -> None: ...
    def onPasteObjects(self) -> None: ...
    def contextMenuEvent(self, event): ...
    @override
    def wheelEvent(self, event): ...
    @override
    def keyPressEvent(self, event): ...
    @override
    def keyReleaseEvent(self, event): ...
    @override
    def mousePressEvent(self, event): ...
    @override
    def mouseMoveEvent(self, event): ...
    @override
    def drawBackground(self, painter, rect): ...
    @override
    def showEvent(self, event): ...
    def nodeScene(self) -> BasicGraphicsScene: ...
    def scenePastePosition(self) -> QtCore.QPointF: ...
