from abc import abstractmethod

from PySide6 import QtCore, QtGui

from SpatialNode.definitions import QJsonObject

class Style:
    def __init__(self): ...
    @abstractmethod
    def loadJson(self, json: QJsonObject): ...
    @abstractmethod
    def toJson(self) -> QJsonObject: ...
    def loadJsonFromByteArray(self, byteArray: QtCore.QByteArray) -> None: ...
    def loadJsonText(self, jsonText: str) -> None: ...
    def loadJsonFile(self, fileName: str) -> None: ...

def json_read_color(
    obj: QJsonObject, key: str, default: QtGui.QColor
) -> QtGui.QColor: ...
def json_read_float(obj: QJsonObject, key: str, default: float) -> float: ...
def json_read_bool(obj: QJsonObject, key: str, default: bool) -> bool: ...
